DECLARE SUB init ()
DECLARE SUB maskAndDraw (direction%)

DEFINT A-Z

TYPE badguy
  bgx AS INTEGER
  bgy AS INTEGER
END TYPE

TYPE players
  px AS INTEGER
  py AS INTEGER
END TYPE

TYPE pit
  pitx AS INTEGER
  pity AS INTEGER
  pitdamage AS INTEGER
END TYPE

DIM SHARED player AS players
DIM SHARED pits(1 TO 5) AS pit
DIM SHARED badguys(1 TO 5) AS badguy
DIM SHARED game AS INTEGER

             
CALL init

WHILE game = 1
a$ = INKEY$

  IF a$ = "4" THEN
    player.px = player.px - 1
    CALL maskAndDraw(4)
  
  ELSEIF a$ = "6" THEN
    player.px = player.px + 1
    CALL maskAndDraw(6)

  ELSEIF a$ = "8" THEN
    player.py = player.py - 1
    CALL maskAndDraw(8)

  ELSEIF a$ = "2" THEN
    player.py = player.py + 1
    CALL maskAndDraw(2)

  ELSEIF a$ = "q" THEN
    game = 0
  END IF

WEND
END

SUB init
CLS
SCREEN 0
game = 1

PRINT "                Mr. Face's SCREEN 0 Adventure!"
PRINT "               ---------------------------------"
PRINT "This computer only supports screen 0 because it's a monochrome"
PRINT "monitor... bummer!"
PRINT "   Number keys move, q is quit. Have fun!"
PRINT
PRINT "           >> Press any key to begin <<"
DO
LOOP WHILE INKEY$ = ""

CLS

LOCATE 10, 10
PRINT CHR$(2)

player.px = 10
player.py = 10

'setting up bad guys
FOR i% = 1 TO 5 STEP 1
  badguys(i%).bgx = (RND(1) * 60) + 1
  badguys(i%).bgy = (RND(1) * 20) + 1
NEXT

FOR i% = 1 TO 5 STEP 1
  LOCATE badguys(i%).bgy, badguys(i%).bgx
  PRINT CHR$(1)
NEXT


'setting up pits
FOR i% = 1 TO 5 STEP 1
  pits(i%).pitx = (RND(1) * 60) + 1
  pits(i%).pity = (RND(1) * 20) + 1
NEXT

FOR i% = 1 TO 5 STEP 1
  LOCATE pits(i%).pity, pits(i%).pitx
  PRINT "*"
NEXT


END SUB

SUB maskAndDraw (direction%)

SELECT CASE direction%

  CASE 2
    LOCATE (player.py - 1), player.px
    PRINT " "

  CASE 4
    LOCATE player.py, (player.px + 1)
    PRINT " "

  CASE 6
    LOCATE player.py, (player.px - 1)
    PRINT " "

  CASE 8
    LOCATE (player.py + 1), player.px
    PRINT " "

END SELECT

LOCATE player.py, player.px
PRINT CHR$(2)
  


END SUB

